require 'active_support/inflector'

module Reencryptor::GlobalToPerAttributeIVSalt 
  class Migrator
    attr_accessor :classes

    def initialize (classes_hash: nil)
      self.classes = classes_hash
    end

    def generate
      puts "Add the following lines to a new migration:"
      self.classes.each do |klass, fields|
        klass_name = klass.to_s.underscore.pluralize.to_sym
        fields.each do |f|
          field = f.to_s.underscore.to_sym
          field_old = fieldname_old(field)
          puts "rename_column :#{klass_name}, :#{fieldname(field)}, :#{field_old}"
          puts "add_column :#{klass_name}, :#{fieldname(field)}, :string"
          puts "add_column :#{klass_name}, :#{fieldname_iv(field)}, :string"
          puts "add_column :#{klass_name}, :#{fieldname_salt(field)}, :string"
        end
      end
      puts "#----- End of Migration -----#"
    end

    def fieldname(field)
      "encrypted_#{field.to_s.downcase}".to_sym
    end

    def fieldname_old(field)
      "encrypted_#{field.to_s.downcase}_old".to_sym
    end

    def fieldname_iv(field)
      "encrypted_#{field.to_s.downcase}_iv".to_sym
    end

    def fieldname_salt(field)
      "encrypted_#{field.to_s.downcase}_salt".to_sym
    end
  end
end
